// ==========================================================================
// $Id$
// provides ppm reader and writer functions
// ==========================================================================
// (C)opyright:
//
//   Max-Planck-Institut fuer Informatik
//   Stuhlsatzenhausweg 85, 66123 Saarbruecken
//   http://www.mpi-sb.mpg.de
// 
// Creator: lensch (Hendrik Lensch)
// Email:   lensch@mpi-sb.mpg.de
// ==========================================================================
// $Log$
// ==========================================================================

#ifndef SOLUTIONEX5_BILATERAL_PPM_H
#define SOLUTIONEX5_BILATERAL_PPM_H

/*! \file  PPM.hh
    \brief provides ppm reader and writer functions
 */
#include <string>

namespace ppm {
  
  bool readPPM( const char* aFileName,        int& oWidth, int& oHeight, float** oData );
  bool readPPM( const std::string& aFileName, int& oWidth, int& oHeight, float*& oData ); 
  
  bool writePPM( const std::string& aFileName, int aWidth, int aHeight, float* aData, 
      const std::string& aMagic = std::string("P6"));
  
} /* namespace */



#endif /* SOLUTIONEX5-BILATERAL_PPM_H */







